# Since only kinput2 package is made, no more advantage to have multiple kinput2-* binary.
# you can choose from the bolow options which binary goes to the package.
#  build_with_wnn4       ... only support wnn4
#  build_with_wnn6       ... only support wnn4 and/or wnn6
#  build_with_canna      ... only support canna
#  build_with_canna_wnn4 ... support canna and wnn4
#  build_with_canna_wnn6 ... support canna and wnn4 and/or wnn6
# if you switch on the multiple option, the symlink to kinput2 will be made in order of this list.
# I mean build_canna_wnn6 is prior than build_wnn4.
%define	build_with_wnn4		0
%define	build_with_wnn6		0
%define build_with_canna	1
%define	build_with_canna_wnn4	0
%define	build_with_canna_wnn6	0

%define	inst_alternatives_canna	alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/ja_JP xinput-ja_JP %{_sysconfdir}/X11/xinit/xinput.d/%{name}-canna 40
%define	inst_alternatives_wnn	alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/ja_JP xinput-ja_JP %{_sysconfdir}/X11/xinit/xinput.d/%{name}-wnn 30
%define	uninst_alternatives_canna	alternatives --remove xinput-ja_JP %{_sysconfdir}/X11/xinit/xinput.d/%{name}-canna
%define	uninst_alternatives_wnn		alternatives --remove xinput-ja_JP %{_sysconfdir}/X11/xinit/xinput.d/%{name}-wnn

%define is_canna_used	%([ '%{build_with_canna}' -eq '1' -o '%{build_with_canna_wnn4}' -eq '1' -o '%{build_with_canna_wnn6}' -eq '1' ] && echo 1 || echo 0)
%define	is_wnn4_used	%([ '%{build_with_wnn4}' -eq '1' -o '%{build_with_canna_wnn4}' -eq '1' ] && echo 1 || echo 0)
%define	is_wnn6_used	%([ '%{build_with_wnn6}' -eq '1' -o '%{build_with_canna_wnn6}' -eq '1' ] && echo 1 || echo 0)
%define	is_wnn_used	%([ '%{is_wnn4_used}' -eq '1' -o '%{is_wnn6_used}' -eq '1' ] && echo 1 || echo 0)

Name: kinput2
Version: v3.1
Release: 39%{?dist}
License: MIT
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: libICE-devel libSM-devel libX11-devel libXaw-devel libXext-devel libXmu-devel libXpm-devel libXt-devel libXp-devel
BuildRequires: imake >= 1.0.1-3
%if %{is_canna_used}
BuildRequires: Canna-devel >= 3.7p1-6
%endif
%if %{is_wnn4_used}
BuildRequires: FreeWnn-devel
%endif
%if %{is_wnn6_used}
BuildRequires: Wnn6-SDK-devel
%endif

Source0: ftp://ftp.sra.co.jp/pub/x11/kinput2/%{name}-%{version}.tar.gz
Source1: Kinput2.conf.canna
Source2: Kinput2.conf.wnn4
Source3: Kinput2.conf.canna-wnn4
Source4: Kinput2.conf.wnn6
Source5: Kinput2.conf.canna-wnn6
Source6: xinput.d-kinput2-canna
Source7: xinput.d-kinput2-wnn
Patch0: Kinput2.ad.patch
Patch1: kinput2.ppc.patch
Patch2: %{name}-v3.libdir.patch
# ia64 patch (but not complete)
Patch3: kinput2-v3.1-ia64.patch
Patch4: kinput2-v3.1-wm_state_above.patch
Patch5: kinput2-v3.1-wm_delete_window.patch
Patch6: kinput2-v3.1-Xsji3clib-fix-typo.patch
Patch7: kinput2-v3.1-fix-gcc-warning.patch
Patch8: kinput2-v3.1-activate_im_with_kanji.patch
Patch9: kinput2-v3.1-jp106_xfer.patch
Patch10: kinput2-v3.1-status-update-204892.patch
Patch11: kinput2-v3.1-linespace.patch

Summary: kinput2 - kanji input server for X11
Group: User Interface/X
Requires(post): %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives
Requires(triggerpostun): %{_sbindir}/alternatives
Requires: im-chooser >= 0.4.1-2.fc8
%if %{is_canna_used}
Requires: Canna
%endif
Obsoletes: kinput2-canna, kinput2-wnn4, kinput2-wnn6, kinput2-canna-wnn4, kinput2-canna-wnn6

%description 
Kinput2 is an input server for X11 applications that want Japanese text input.

%prep
%setup -q
cp -a ${RPM_SOURCE_DIR}/Kinput2.conf.* .
%patch0 -p1
%ifarch ppc
%patch1 -p1
%endif
%patch2 -p1
%patch3 -p1 -b .ia64
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

head -21 cmd/kinput2.c >Copyright

%build

fixoptflags() {
	find . -name Makefile \
	| xargs sed -i -e 's/^\(\s*CDEBUGFLAGS\s*=.*\)/\1 $(RPM_OPT_FLAGS)/'
}

%if %{build_with_wnn4}
ln -sf Kinput2.conf.wnn4 Kinput2.conf
xmkmf -a
fixoptflags
make %{?_smp_mflags}
mv cmd/kinput2 kinput2.wnn4
make clean
%endif

%if %{build_with_wnn6}
ln -sf Kinput2.conf.wnn6 Kinput2.conf
xmkmf -a
fixoptflags
make %{?_smp_mflags}
mv cmd/kinput2 kinput2.wnn6
make clean
%endif

%if %{build_with_canna}
rm -f Kinput2.conf
ln -sf Kinput2.conf.canna Kinput2.conf
xmkmf -a
fixoptflags
make %{?_smp_mflags}
mv cmd/kinput2 kinput2.canna
make clean
%endif

%if %{build_with_canna_wnn4}
ln -sf Kinput2.conf.canna-wnn4 Kinput2.conf
xmkmf -a
fixoptflags
make %{?_smp_mflags}
mv cmd/kinput2 kinput2.canna-wnn4
make clean
%endif

%if %{build_with_canna_wnn6}
ln -sf Kinput2.conf.canna-wnn6 Kinput2.conf
xmkmf -a
fixoptflags
make %{?_smp_mflags}
mv cmd/kinput2 kinput2.canna-wnn6
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}

%if %{build_with_wnn4}
install -p -m 0755 kinput2.wnn4       $RPM_BUILD_ROOT%{_bindir}
%endif
%if %{build_with_wnn6}
install -p -m 0755 kinput2.wnn6       $RPM_BUILD_ROOT%{_bindir}
%endif
%if %{build_with_canna}
install -p -m 0755 kinput2.canna      $RPM_BUILD_ROOT%{_bindir}
%endif
%if %{build_with_canna_wnn4}
install -p -m 0755 kinput2.canna-wnn4 $RPM_BUILD_ROOT%{_bindir}
%endif
%if %{build_with_canna_wnn6}
install -p -m 0755 kinput2.canna-wnn6 $RPM_BUILD_ROOT%{_bindir}
%endif

mkdir -p $RPM_BUILD_ROOT%{_datadir}/X11/app-defaults
install -p -m 0444 cmd/Kinput2.ad $RPM_BUILD_ROOT%{_datadir}/X11/app-defaults/Kinput2

%if %{is_wnn_used}
mkdir -p $RPM_BUILD_ROOT/usr/lib/X11/ccdef
install -p -m 0444 ccdef/ccdef.* $RPM_BUILD_ROOT/usr/lib/X11/ccdef
install -p -m 0444 ccdef/rule.*  $RPM_BUILD_ROOT/usr/lib/X11/ccdef
%endif

make install.man DESTDIR=$RPM_BUILD_ROOT

%if %{is_canna_used}
install -D -m 0644 -p %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d/%{name}-canna
%endif
%if %{is_wnn_used}
install -D -m 0644 -p %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d/%{name}-wnn
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %([ '%{build_with_wnn4}' -eq '1' -a '%{build_with_wnn6}' -eq '0' -a '%{build_with_canna}' -eq '0' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.wnn4 %{_bindir}/kinput2
%endif
%if %([ '%{build_with_wnn6}' -eq '1' -a '%{build_with_canna}' -eq '0' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.wnn6 %{_bindir}/kinput2
%endif
%if %([ '%{build_with_canna}' -eq '1' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.canna %{_bindir}/kinput2
%endif
%if %([ '%{build_with_canna_wnn4}' -eq '1' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.canna-wnn4 %{_bindir}/kinput2
%endif
%if %{build_with_canna_wnn6}
ln -sf kinput2.canna-wnn6 %{_bindir}/kinput2
%endif
%if %{is_canna_used}
%{inst_alternatives_canna}
%endif
%if %{is_wnn_used}
%{inst_alternatives_wnn}
%endif

%preun
if [ "$1" = 0 ]; then
	rm -rf %{_bindir}/kinput2
%if %{is_canna_used}
	%{uninst_alternatives_canna}
%endif
%if %{is_wnn_used}
	%{uninst_alternatives_wnn}
%endif
fi

%triggerpostun -- kinput2-canna-wnn6
%if %([ '%{build_with_wnn4}' -eq '1' -a '%{build_with_wnn6}' -eq '0' -a '%{build_with_canna}' -eq '0' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.wnn4 %{_bindir}/kinput2
%endif
%if %([ '%{build_with_wnn6}' -eq '1' -a '%{build_with_canna}' -eq '0' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.wnn6 %{_bindir}/kinput2
%endif
%if %([ '%{build_with_canna}' -eq '1' -a '%{build_with_canna_wnn4}' -eq '0' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.canna %{_bindir}/kinput2
%endif
%if %([ '%{build_with_canna_wnn4}' -eq '1' -a '%{build_with_canna_wnn6}' -eq '0' ] && echo 1 || echo 0)
ln -sf kinput2.canna-wnn4 %{_bindir}/kinput2
%endif
%if %{build_with_canna_wnn6}
ln -sf kinput2.canna-wnn6 %{_bindir}/kinput2
%endif
%if %{is_canna_used}
%{inst_alternatives_canna}
%endif
%if %{is_wnn_used}
%{inst_alternatives_wnn}
%endif

%files
%defattr(-, root, root)
%doc Copyright NEWS README doc
%config %{_datadir}/X11/app-defaults/Kinput2
%if %{is_wnn_used}
/usr/lib/X11/ccdef
%endif
%{_bindir}/kinput2*
%{_mandir}/man1/kinput2.1x*
%{_sysconfdir}/X11/xinit/xinput.d

%changelog
* Tue Sep  2 2008 Akira TAGOH <tagoh@redhat.com> - v3.1-39
- Fix a value type of lineSpace attribute. (#458650)

* Tue Feb 19 2008 Akira TAGOH <tagoh@redhat.com> - v3.1-38
- Fix xinput script to get it working on latest im-chooser.

* Tue Feb 12 2008 Akira TAGOH <tagoh@redhat.com> - v3.1-37
- Rebuild for gcc-4.3.

* Fri Sep 28 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-36
- Add Requires: Canna to get it working just installing the package.
- clean up a bit the spec file.

* Thu Sep 20 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-35
- Add the versioned dependency for im-chooser.

* Wed Sep  5 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-34
- Add QT_IM_MODULE=xim to the xinput script.

* Thu Aug 23 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-33
- Rebuild

* Thu Aug  9 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-32
- Update License tag.

* Tue Feb 13 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-31
- Build with RPM_OPT_FLAGS. (#227752)

* Fri Jan 26 2007 Akira TAGOH <tagoh@redhat.com> - v3.1-30
- Backport a patch to update the status with XmbResetIC() properly.
- Disable Wnn support so that no *Wnn* devel package available anymore.

* Mon Sep 11 2006 Akira TAGOH <tagoh@redhat.com> - v3.1-29
- rebuilt

* Wed Jul 12 2006 Akira TAGOH <tagoh@redhat.com> - v3.1-28
- add Requires: im-chooser to support new xinput.sh.

* Tue Mar  7 2006 Akira TAGOH <tagoh@redhat.com> - v3.1-27
- moved out from /usr/X11R6. (#170934)

* Tue Jul 12 2005 Akira TAGOH <tagoh@redhat.com> - v3.1-26
- use proper xinput script for kinput2-wnn.

* Thu Jun 30 2005 Akira TAGOH <tagoh@redhat.com> - v3.1-25
- Import into Extras.

* Tue Feb  8 2005 Akira TAGOH <tagoh@redhat.com> - v3.1-24
- kinput2-redraw.patch: applied to commit the strings after pressing
  Right button say. (#146204)

* Fri Oct  8 2004 Akira TAGOH <tagoh@redhat.com> - v3.1-23
- added BuildRequires xorg-x11-devel (#134950)

* Fri Jul 02 2004 Akira TAGOH <tagoh@redhat.com> v3.1-22
- doh. add %%triggerpostun to recreate a symlink and the alternatives which was
  removed by older kinput2-* package's %preun. and no need to make a dummy
  package then.

* Fri Jul 02 2004 Akira TAGOH <tagoh@redhat.com> v3.1-21
- package only kinput2-canna-wnn4 by default.
  NOTE: if you need other binaries, you need to rebuild this from srpm.
        please see the top of this spec file for more details.
- now all binary packages is into kinput2 package.
  kinput2-canna-wnn6 is a dummy package to allow people to upgrade it safely.
- clean up the spec file.

* Wed Jun 30 2004 Akira TAGOH <tagoh@redhat.com> v3.1-20
- add xinput.d support.
- require alternatives for %%post and %%preun
  now switching the input method is managed by alternatives.
  the priority is set to 40 to use Canna
  the priority is set to 30 to use Wnn

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Mar 23 2004 Akira TAGOH <tagoh@redhat.com> v3.1-18
- rebuilt to satisfy the dependency.

* Wed Feb 18 2004 Akira TAGOH <tagoh@redhat.com> v3.1-16
- kinput2-v3.1-activate_im_with_kanji.patch: applied to activate the input method against Kanji key.
- kinput2-v3.1-jp106_xfer.patch: applied to support Henkan key.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Feb 12 2004 Akira TAGOH <tagoh@redhat.com> v3.1-14
- kinput2-v3.1-fix-gcc-warning.patch: applied to fix gcc warning. (#114750)

* Thu Jan 08 2004 Akira TAGOH <tagoh@redhat.com> v3.1-13
- kinput2-v3.1-Xsji3clib-fix-typo.patch: applied a patch from Dave Jones to fix a typo.

* Wed Nov 05 2003 Akira TAGOH <tagoh@redhat.com> v3.1-12.EL
- rebuilt

* Tue Nov 04 2003 Akira TAGOH <tagoh@redhat.com> v3.1-12
- kinput2-v3.1-wm_delete_window.patch: to avoid to kill itself when clicking the close button on the candidate window. (#104295)

* Thu Oct 16 2003 Akira TAGOH <tagoh@redhat.com> v3.1-11
- kinput2-v3.1-ia64.patch: updated to fix FreeWnn not working on ia64. (#106048)

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Apr 23 2003 Akira TAGOH <tagoh@redhat.com> v3.1-9
- rebuild.

* Tue Apr 22 2003 Akira TAGOH <tagoh@redhat.com> v3.1-8
- Kinput2.ad.patch: update to contains the resources for avoiding the input focus issue. (#78017)

* Thu Mar 27 2003 Akira TAGOH <tagoh@redhat.com> v3.1-7
- Rebuild against the latest Canna.

* Tue Mar 25 2003 Akira TAGOH <tagoh@redhat.com> v3.1-6
- doh! patch4 was not applied. this release is necessary to really fix #84960.

* Tue Feb 25 2003 Akira TAGOH <tagoh@redhat.com> v3.1-4
- kinput2-v3.1-wm_state_above.patch: don't hide the candidate window under
  the panel. (#84960)

* Thu Jan 30 2003 Yukihiro Nakai <ynakai@redhat.com>
- Update to v3.1

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan  7 2003 Tim Powers <timp@redhat.com>
- bump release number

* Mon Dec 16 2002 Yukihiro Nakai <ynakai@redhat.com>
- Update kinput2 resource to support the UTF-8 locale
- Update kinput2 resource to support the Unix domain socket FreeWnn

* Wed Nov 20 2002 Tim Powers <timp@redhat.com>
- rebuild on all arches

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun 19 2002 Akira TAGOH <tagoh@redhat.com> v3-17
- fix the stripped binary.
- s/Copyright/License/

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue Jul 24 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add Canna-devel and Wnn6-SDK to BuildPrereq (#49881)

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Wed Dec 13 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add IA64 patch (but not complete)
- Provide only kinput2-canna-wnn6 by default

* Tue Sep 12 2000 Satoru Sato <ssato@redhat.com>
- Add Conflicts

* Fri Aug 11 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add BuildPrereq

* Fri Aug 04 2000 Yukihiro Nakai <ynakai@redhat.com>
- Fix for sawfish
- Rebuild for 7.0J

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jun 12 2000 Matt Wilson <msw@redhat.com>
- merge to head development

* Wed Mar 15 2000 Matt Wilson <msw@redhat.com>
- rebuilt for 6.2j
- rebuilt against FreeWnn (just in case)
- gzip man pagesc

* Sat Mar  4 2000 Chris Ding <cding@redhat.com>
- changed group

* Wed Oct  6 1999 Matt Wilson <msw@redhat.com>
- rebuilt for 6.1

* Wed Jul 07 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- built against glibc-2.1

* Mon Jun 28 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 2nd. release
- defined LIBDIR as /var/lib/wnn in lib/wnnlib.c
  thanks Satoshi Ishikawa <tigre@cc.gifu-u.ac.jp>

* Mon May 31 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version v3

* Wed May 26 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version v3-beta4

* Mon May 10 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version v3-beta3

* Tue Apr 20 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version v3-beta2

* Fri Mar 19 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- version up to v2-fix5-alpha8

* Mon Mar  8 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- version up to v2-fix5-alpha7

* Mon Feb  8 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- version up to v2-fix5-alpha6

* Wed Jan 27 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 2nd release
- prepared Kinput2.conf file as a source

* Thu Jan 21 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- version up to v2-fix5-alpha5
- wnn -> wnn4
- added wnn6 and canna-wnn6
- Extensions/Japanese -> X11/Utilities

* Wed Jul 29 1998 Susumu Nagashige <nagasige@ops.dti.ne.jp>
- 4th Release.
- removed binary dependency.
- removed common package.

* Wed May 13 1998 Susumu Nagashige <nagasige@netlaputa.ne.jp>
- 3rd Release.
- added FilterEvent Patch

* Mon Feb 23 1998 Susumu Nagashige <nagasige@netlaputa.ne.jp>
- 2nd Release.
- fix to RedHat-5.0

* Sat Dec 13 1997 Susumu Nagashige <nagasige@netlaputa.ne.jp>
- 1st Release
